# Generated by Django 2.2 on 2019-05-15 10:54

import datetime
from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Chapter',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('title', models.CharField(blank=True, max_length=255, null=True)),
                ('num_chapter', models.IntegerField()),
                ('url_chapter', models.CharField(blank=True, max_length=255, null=True)),
            ],
        ),
        migrations.CreateModel(
            name='Character',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('name_surname', models.CharField(max_length=255, unique=True)),
            ],
        ),
        migrations.CreateModel(
            name='Fandom',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('name', models.CharField(max_length=255)),
                ('avatar', models.ImageField(default='profiles/default.png', upload_to='fanfics')),
            ],
        ),
        migrations.CreateModel(
            name='Fanfic',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('name', models.CharField(max_length=255)),
                ('author', models.CharField(max_length=255)),
                ('web', models.CharField(max_length=255, unique=True)),
                ('language', models.CharField(blank=True, max_length=255, null=True)),
                ('genre1', models.CharField(blank=True, choices=[('adv', 'adventure'), ('ang', 'angst'), ('dra', 'drama'), ('fri', 'friendship'), ('gen', 'general'), ('hum', 'humor'), ('hur', 'hurt/comfort'), ('mys', 'mystery'), ('rom', 'romance'), ('tra', 'tragedy'), ('hor', 'horror'), ('fan', 'fantasy')], max_length=3, null=True)),
                ('genre2', models.CharField(blank=True, choices=[('adv', 'adventure'), ('ang', 'angst'), ('dra', 'drama'), ('fri', 'friendship'), ('gen', 'general'), ('hum', 'humor'), ('hur', 'hurt/comfort'), ('mys', 'mystery'), ('rom', 'romance'), ('tra', 'tragedy'), ('hor', 'horror'), ('fan', 'fantasy')], max_length=3, null=True)),
                ('genre3', models.CharField(blank=True, choices=[('adv', 'adventure'), ('ang', 'angst'), ('dra', 'drama'), ('fri', 'friendship'), ('gen', 'general'), ('hum', 'humor'), ('hur', 'hurt/comfort'), ('mys', 'mystery'), ('rom', 'romance'), ('tra', 'tragedy'), ('hor', 'horror'), ('fan', 'fantasy')], max_length=3, null=True)),
                ('genre4', models.CharField(blank=True, choices=[('adv', 'adventure'), ('ang', 'angst'), ('dra', 'drama'), ('fri', 'friendship'), ('gen', 'general'), ('hum', 'humor'), ('hur', 'hurt/comfort'), ('mys', 'mystery'), ('rom', 'romance'), ('tra', 'tragedy'), ('hor', 'horror'), ('fan', 'fantasy')], max_length=3, null=True)),
                ('last_time_checked', models.DateTimeField(default=datetime.datetime.now)),
                ('status', models.CharField(blank=True, choices=[('c', 'completed'), ('i', 'in progress')], max_length=1, null=True)),
                ('last_time_updated', models.DateTimeField(blank=True, null=True)),
                ('num_chapters', models.IntegerField(blank=True, null=True)),
                ('num_words', models.IntegerField(blank=True, null=True)),
                ('rating', models.CharField(blank=True, choices=[('K', 'K'), ('K+', 'K+'), ('T', 'T'), ('M', 'M')], max_length=2, null=True)),
                ('average_score', models.FloatField(blank=True, null=True)),
            ],
        ),
        migrations.CreateModel(
            name='Type',
            fields=[
                ('name', models.CharField(max_length=10, primary_key=True, serialize=False)),
            ],
        ),
        migrations.CreateModel(
            name='Review',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('text', models.TextField(blank=True, null=True)),
                ('score', models.FloatField()),
                ('date', models.DateField(auto_now=True)),
                ('fanfic', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='common.Fanfic')),
                ('user', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='Related',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('fanfic_one', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='fanfic_one', to='common.Fanfic')),
                ('fanfic_two', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='fanfic_two', to='common.Fanfic')),
            ],
        ),
        migrations.CreateModel(
            name='Reading',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date', models.DateField(auto_now=True)),
                ('private_notes', models.TextField(blank=True, null=True)),
                ('chapter', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, to='common.Chapter')),
                ('user', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='PrivateMessage',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('text', models.TextField()),
                ('subject', models.CharField(max_length=100)),
                ('date', models.DateField(auto_now=True)),
                ('receiver', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='user_receiver', to=settings.AUTH_USER_MODEL)),
                ('sender', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='user_sender', to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='Pairing',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('character_one', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='character_pairing_one', to='common.Character')),
                ('character_two', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='character_pairing_two', to='common.Character')),
                ('fanfic', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='common.Fanfic')),
            ],
        ),
        migrations.CreateModel(
            name='List',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('name', models.CharField(max_length=255, unique=True)),
                ('user', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='FanficList',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date', models.DateTimeField(auto_now=True)),
                ('fanfic', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='common.Fanfic')),
                ('list', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='common.List')),
            ],
        ),
        migrations.CreateModel(
            name='FandomFanfic',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('fandom', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='common.Fandom')),
                ('fanfic', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='common.Fanfic')),
            ],
        ),
        migrations.AddField(
            model_name='fandom',
            name='type',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='common.Type'),
        ),
        migrations.CreateModel(
            name='CharacterFanfic',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('character', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='common.Character')),
                ('fanfic', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='common.Fanfic')),
            ],
        ),
        migrations.AddField(
            model_name='character',
            name='fandom',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, to='common.Fandom'),
        ),
        migrations.AddField(
            model_name='chapter',
            name='fanfic',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, to='common.Fanfic'),
        ),
    ]
